/**********
 * Polprog 2018
 * 3 clause BSD licence
 * http://polprog.net
 */
#include <termios.h>
#include <stdio.h>

#include "util.h"


int main(int argc, char** argv){

  if (argc < 2) {
    printf("Usage: %s <port>\n", argv[0]);
    exit(1);
  }

  
  struct termios options; //serial port options

  printf("Initializing serial port: 9600 8n1\n");
  //initialize serial port

  int portfd = open_port(argv[1]);
  tcgetattr(portfd, &options);
  cfsetispeed(&options, B9600);
  cfsetospeed(&options, B9600);
  
  options.c_cflag &= ~CRTSCTS; //no hw flow control
  options.c_cflag &= ~PARENB;
  options.c_cflag &= ~CSTOPB;
  options.c_cflag &= ~CSIZE; /* Mask the character size bits */
  options.c_cflag |= CS8;    /* Select 8 data bits */
  options.c_cflag |= (CLOCAL | CREAD);
  options.c_lflag &= ~(ICANON | ECHO | ECHOE | ISIG); //raw input
  fcntl(portfd, F_SETFL, FNDELAY); //enable blocking
  tcsetattr(portfd, TCSANOW, &options);

  printf("Port attributes set\n");


  char *input, *output;
  input = malloc(16);
  output = malloc(16);
  scanf("%s", input);
  write_chars(portfd, input);
  write_chars(portfd, "\r");
  tcdrain(portfd);
  usleep(10000);
  read_line(portfd, output);
  printf("AVR returned: %s\n", output);

  free(input);
  free(output);
  return 0;
}
